*** empty log message ***
[platform/upstream/coreutils.git] / src / groups.sh
1 #!/bin/sh
2 # groups -- print the groups a user is in
3 # Copyright (C) 1991, 1997, 2000, 2002, 2004 Free Software Foundation, Inc.
4
5 # This program is free software; you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation; either version 2, or (at your option)
8 # any later version.
9
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software Foundation,
17 # Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
18
19 # Written by David MacKenzie <djm@gnu.ai.mit.edu>.
20
21 # Make sure we get GNU id, if possible; also allow
22 # it to be somewhere else in PATH if not installed yet.
23 PATH=@bindir@:$PATH
24
25 usage="Usage: $0 [OPTION]... [USERNAME]...
26
27   --help      display this help and exit
28   --version   output version information and exit
29
30 Same as id -Gn.  If no USERNAME, use current process.
31
32 Report bugs to <@PACKAGE_BUGREPORT@>."
33
34 version='groups (@GNU_PACKAGE@) @VERSION@
35 Written by David MacKenzie.
36
37 Copyright (C) 2004 Free Software Foundation, Inc.
38 This is free software; see the source for copying conditions.  There is NO
39 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.'
40
41
42 fail=0
43 case $# in
44   1 )
45     case "z${1}" in
46       z--help )
47          echo "$usage" || fail=1; exit $fail;;
48       z--version )
49          echo "$version" || fail=1; exit $fail;;
50       * ) ;;
51     esac
52     ;;
53   * ) ;;
54 esac
55
56 if [ $# -eq 0 ]; then
57   id -Gn
58   fail=$?
59 else
60   for name in "$@"; do
61     groups=`id -Gn -- $name`
62     status=$?
63     if test $status = 0; then
64       echo $name : $groups
65     else
66       fail=$status
67     fi
68   done
69 fi
70 exit $fail